#define USERS 10

chan serv = [1] of {int};  //request token
chan tok[USERS] = [1] of {bool}; //give token
chan ret = [1] of {bool}; //return token
int CS = 0;

proctype Sem(){
    int i; bool dum;
    do
    :: serv ? i;
       tok[i]! dum;
       ret? dum;
    od
}

proctype U(int i){
    bool dum;
    do
    :: serv ! i;
       tok[i]? dum;
       printf("User %d enters CS\n", i);
       CS++;
       assert (CS <= 1);
       CS--;
       printf("User %d leaves CS\n", i);
       ret ! true
    od
}

init{
    int i=0;
    do
    :: i > USERS-1 -> break;
    :: else -> run U(i); i++
    od;
    run Sem()}
